package org.jeecg.modules.sampleAndConsumableManagement.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.sampleAndConsumableManagement.entity.FdColumnManagementRecipientRecord;
import org.jeecg.modules.sampleAndConsumableManagement.service.IFdColumnManagementRecipientRecordService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 色谱柱管理领用记录
 * @author： jeecg-boot
 * @date：   2019-06-11
 * @version： V1.0
 */
@RestController
@RequestMapping("/sampleAndConsumableManagement/fdColumnManagementRecipientRecord")
@Slf4j
public class FdColumnManagementRecipientRecordController {
	@Autowired
	private IFdColumnManagementRecipientRecordService fdColumnManagementRecipientRecordService;
	
	/**
	  * 分页列表查询
	 * @param fdColumnManagementRecipientRecord
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FdColumnManagementRecipientRecord>> queryPageList(FdColumnManagementRecipientRecord fdColumnManagementRecipientRecord,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FdColumnManagementRecipientRecord>> result = new Result<IPage<FdColumnManagementRecipientRecord>>();
		QueryWrapper<FdColumnManagementRecipientRecord> queryWrapper = QueryGenerator.initQueryWrapper(fdColumnManagementRecipientRecord, req.getParameterMap());
		Page<FdColumnManagementRecipientRecord> page = new Page<FdColumnManagementRecipientRecord>(pageNo, pageSize);
		IPage<FdColumnManagementRecipientRecord> pageList = fdColumnManagementRecipientRecordService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fdColumnManagementRecipientRecord
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FdColumnManagementRecipientRecord> add(@RequestBody FdColumnManagementRecipientRecord fdColumnManagementRecipientRecord) {
		Result<FdColumnManagementRecipientRecord> result = new Result<FdColumnManagementRecipientRecord>();
		try {
			fdColumnManagementRecipientRecordService.save(fdColumnManagementRecipientRecord);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fdColumnManagementRecipientRecord
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FdColumnManagementRecipientRecord> edit(@RequestBody FdColumnManagementRecipientRecord fdColumnManagementRecipientRecord) {
		Result<FdColumnManagementRecipientRecord> result = new Result<FdColumnManagementRecipientRecord>();
		FdColumnManagementRecipientRecord fdColumnManagementRecipientRecordEntity = fdColumnManagementRecipientRecordService.getById(fdColumnManagementRecipientRecord.getId());
		if(fdColumnManagementRecipientRecordEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdColumnManagementRecipientRecordService.updateById(fdColumnManagementRecipientRecord);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FdColumnManagementRecipientRecord> delete(@RequestParam(name="id",required=true) String id) {
		Result<FdColumnManagementRecipientRecord> result = new Result<FdColumnManagementRecipientRecord>();
		FdColumnManagementRecipientRecord fdColumnManagementRecipientRecord = fdColumnManagementRecipientRecordService.getById(id);
		if(fdColumnManagementRecipientRecord==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdColumnManagementRecipientRecordService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FdColumnManagementRecipientRecord> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FdColumnManagementRecipientRecord> result = new Result<FdColumnManagementRecipientRecord>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fdColumnManagementRecipientRecordService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FdColumnManagementRecipientRecord> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FdColumnManagementRecipientRecord> result = new Result<FdColumnManagementRecipientRecord>();
		FdColumnManagementRecipientRecord fdColumnManagementRecipientRecord = fdColumnManagementRecipientRecordService.getById(id);
		if(fdColumnManagementRecipientRecord==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fdColumnManagementRecipientRecord);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FdColumnManagementRecipientRecord> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FdColumnManagementRecipientRecord fdColumnManagementRecipientRecord = JSON.parseObject(deString, FdColumnManagementRecipientRecord.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fdColumnManagementRecipientRecord, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FdColumnManagementRecipientRecord> pageList = fdColumnManagementRecipientRecordService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "色谱柱管理领用记录列表");
      mv.addObject(NormalExcelConstants.CLASS, FdColumnManagementRecipientRecord.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("色谱柱管理领用记录列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FdColumnManagementRecipientRecord> listFdColumnManagementRecipientRecords = ExcelImportUtil.importExcel(file.getInputStream(), FdColumnManagementRecipientRecord.class, params);
              for (FdColumnManagementRecipientRecord fdColumnManagementRecipientRecordExcel : listFdColumnManagementRecipientRecords) {
                  fdColumnManagementRecipientRecordService.save(fdColumnManagementRecipientRecordExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFdColumnManagementRecipientRecords.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
